#ifndef WSL
#define WSL
#include "WTL.H"
#define CONST_CS      1.414213562373095146
//======================================================================
//  
// 
scomplex U_CompSh(integer k) {
    TRIG_VVARS;
    for(i=0;i<k;i++) {
     if(i>=k/4 && i<3*k/4) S.Mas[i]=SET_ELEM(0,0);
     else S.Mas[i]=SET_ELEM(CONST_CS,0);
    }
    S=FFT(S,-1);
    return S;
};
//======================================================================
// 
scomplex V_CompSh(integer k) {
    TRIG_VVARS;
    for(i=0;i<k;i++) {
     if(i>=k/4 && i<3*k/4) S.Mas[i]=SET_ELEM(CONST_CS,0);
     else S.Mas[i]=SET_ELEM(0,0);
    }
    S=FFT(S,-1);
    return S;
};
//======================================================================
//   :
scomplex* Filtrs_CompSh(integer k,integer p) {
    TRIG_FVARS
    WORK(CompSh)
    FREE_MEMORY
    return Filtr;
}
//======================================================================
//         
integer CompSh_MAX_ITER(integer k) {
    integer p=0;
    real d=k;
    while(1) {
		d/=2;
		if(d==(integer)d) p++;
		else break;
	}
    if(p) return p-2;
    return p;
};
#endif
